<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\Response;
use Illuminate\Support\Facades\Auth;

class CekRole
{
    /**
     * Handle an incoming request.
     *
     * @param  \Closure(\Illuminate\Http\Request): (\Symfony\Component\HttpFoundation\Response)  $next
     */
    public function handle(Request $request, Closure $next, ...$roles): Response
{
    if (!Auth::check()) {
        return redirect('/login')->with('error', 'Silakan login dulu.');
    }

    $user = Auth::user();

    // Ambil nama role dari relasi role
    $userRoleName = $user->role->name ?? null;

    if (!in_array($userRoleName, $roles)) {
        return abort(403, 'Kamu tidak punya akses ke halaman ini.');
    }

    return $next($request);
}
}
